*
      SUBROUTINE CAL_GESVD1N( NAME, M, N, NPROW, NPCOL, AMEM,
     $                       MEMSIZE, NB, INFILEA, OUTFILE,
     $                       TFILE, NPRT, CTXT )
*
*      (PDGESVD1, PDGESVD4)
*        QD - 
*
      include 'mpif.h'
*
*  
      INTEGER            M, N, NPROW, NPCOL, NB, MEMSIZE,
     $                   NPRT, CTXT
      DOUBLE PRECISION   AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, OUTFILE, NAME, TFILE
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT1 = 12, NOUT = 13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            I, IAM, INFO, IA, JA,
     $                   IPA, IPS, IPW, IPWOR,
     $                   LWMIN, MAXIM, MP, MMIN,
     $                   NP, NQ, NP0, NQ0, MYCOL, MYROW,
     $                   MXNP, MXNQ, LWORK,
     $                   NPROCS, WORKSIZ, SIZE, SIZEB,
     $                   WATOBD, WBDTOSVD, WDBDSQR, WPDGEBRD, WPDLANGE
*  
      INTEGER            DESCA( 9 )
*
      DOUBLE PRECISION   time, time1, time2
*
      COMMON             time, J
*
*  
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, IGSUM2D, PDLAPRNT,
     $                   PDLAREAD, PDLAWRITE, PDGESVD1, PDGESVD4,
     $                   MINTGESVD1
*
*  
      INTRINSIC          MAX, MIN
*
*  
*
*  
*
      IA = 1
      JA = 1
*
*    BLACS'    
***
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       MP = NUMROC( M, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A
*
      CALL DESCINIT(DESCA, M, N, NB, NB, 0, 0, CTXT, MAX(1,MP), INFO)
*
      SIZE = MIN( M, N )
      SIZEB = MAX( M, N )
*
*     AMEM
*
*     A
      IPA = 1
*
*     S (   )
      IPS = IPA + DESCA(9)*NQ
*     WORK
      IPWOR = IPS + SIZE
*
      MP0 = NUMROC( M, NB, 0, 0, NPROW )
      NQ0 = NUMROC( N, NB, 0, 0, NPCOL )
*
      MAXIM = MAX( MP0, NQ0 )
*
      WPDLANGE = MP
      WPDGEBRD = NB*( MP+NQ+1 ) + NQ
      WATOBD = MAX( MAX( WPDLANGE, WPDGEBRD ), MAXIM )
*
      WDBDSQR = MAX( 1, 2*SIZE )
      WBDTOSVD =  MAX( WDBDSQR, 0)
*
      LWMIN = 2 + 6*SIZEB + MAX( WATOBD, WBDTOSVD )
*
*   ,    PDGESVD1(4)
      LWORK = LWMIN
*
*     W
      IPW = IPWOR + LWORK
*
      IF( NAME .NE. 'PDGESVD1' .AND. NAME .NE. 'PDGESVD4' ) GOTO 10
*
*     PDLAPRNT  .
*?
    3 WORKSIZ = MAX( NB, MP )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN') 
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         GO TO 10
      END IF
*
*   ( )     A
*
      IF( INFILEA .EQ. ' ' ) THEN
         CALL MINTGESVD1( M, N, AMEM(IPA), DESCA, INFO )
      ELSE
         CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
      END IF
*
*    
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 .OR. NPRT .EQ. 2 ) GO TO 8
      IF( J .NE. 1 ) GO TO 8
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )M, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )' IPA,  IPS,  IPWOR,  IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPS, IPWOR, IPW, MMIN
*
         WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
      CALL PDLAPRNT( M, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
 9994 FORMAT( / I3, 4I7 /)
 9985 FORMAT( / 9I5 /)
*
*    
*
    8 IF( NAME .EQ. 'PDGESVD4' ) GOTO 11
      IF( NAME .NE. 'PDGESVD1' ) GOTO 10
*
      time1 = MPI_Wtime()
*
      CALL PDGESVD1( N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPS), AMEM(IPWOR), LWORK, INFO )
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
 9999 FORMAT( /' (Wtime) =', D14.3, ' time1 =', D12.3,
     $        ' time2 =', D14.3 )
*
      GOTO 99
*
   11 time1 = MPI_Wtime()
*
      CALL PDGESVD4( M, N, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPS), AMEM(IPWOR), LWORK, INFO)
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*
*  
*
   99 CONTINUE
*
*   
*
      IF( J .NE. 1 .AND. J .NE. 2000 ) GO TO 25
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 ) GO TO 28
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9996 )INFO
*
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
*
         WRITE( NPR, FMT = * ) '   '
         DO 12 I = IPS, IPS+SIZE-1
         PRINT *, ' S(', I-IPS+1, ')=', AMEM( I ), ';'
   12   CONTINUE
      END IF
*
 9990 FORMAT( / ' M = ', I5 /)
*
***
   28 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = * )' : ', MMIN, MEMSIZE, J
      END IF
   25 CONTINUE
*
*        
*  ,      ' '.
***
*
      IF( OUTFILE .EQ. ' ' ) GO TO 30
***
*     
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   '
*
         WRITE(NOUT, FMT = *) SIZE, 1
         DO 14 I = 1, SIZE
            WRITE( NOUT, FMT = * ) AMEM( IPS+I-1 )
   14    CONTINUE
*
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
***
   30 CONTINUE
*
*         WRITE( NPR, FMT = * ) '  '
*
*       
*   ,  
***
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
        IF( J .NE. 1 ) GO TO 31
*
          WRITE( NOUT1, FMT = * )' : ', MMIN, MEMSIZE, J
*
   31   WRITE( NOUT1, FMT = 2001 ) NPROW, NPCOL, NB, time
*
**         WRITE( NOUT1, FMT = 9999 )time, time1, time2
      END IF
*
   10 CONTINUE
*
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
 2001 FORMAT( 3I5, D14.3/ )
*
 9992 FORMAT( / '    ', A8 )
 9998 FORMAT(/'      ',//,
     $       ' A  -   ',I5,'  ',I5,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I3, ' ,',
     $       '    ', I2, '  ', I2 /)
 9996 FORMAT( / '  INFO  = ', I6 /)
 9984 FORMAT( / ' LWORK  = ', D7.17 /)
      RETURN
      END
